{
  Genauigkeit beim Maschinellen Gleichungsloesen an Hand der quadratischen
  Gleichung. x^2 + px + q = 0

  erste Testphase:
  p: -10^3   bis  -10^12           q: 1      ausprobieren.

  zweite Testphase:
  p: -10^100  bis -10^300          q: 1      ausprobieren.
  Hier ergibt sich ab p = -10^154 ein Gleitkommaueberlauf. Man kommentiert im
  Hauptprogramm einfach den Aufruf des Unterprogramms haendisch aus. Danach
  kann das Programm wieder kompiliert werden.
}

PROGRAM QuadratG;
USES CRT;

CONST
EPS = 1.0E-10;                                       (* fuer Nullvergleich *)

TYPE COMPLEX = RECORD                                 (* zur Rueckrechnung *)
                 re : DOUBLE;
                 im : DOUBLE;
               END;

VAR
p,q : DOUBLE;
Hrpre,Hrqre,Mrpre,Mrqre : double;                    { r = zurueckgerechnet }
Hrpim,Hrqim,Mrpim,Mrqim : double;
Hx1re,Hx2re,Mx1re,Mx2re :double;               { H = haendisch M = Maschine }
Hx1im,Hx2im,Mx1im,Mx2im :double;

{ ---------------------------- Unterprogramme ----------------------------- }
PROCEDURE Eingabe;
BEGIN
  CLRSCR;
  WRITELN;
  WRITELN('Das Programm loest die quadratische Gleichung von der Form');
  WRITELN(' x^2 + p*x + q = 0  auf zwei Arten:');
  WRITELN(' fuer p =  -10^3 bis -10^12         fuer q = 1 eingeben');
  WRITELN;
  WRITE('p (z.B.: -1.0E10) : '); READLN(p);
  WRITE('q (z.B.: 1.0: '); READLN(q);
END;

PROCEDURE Ueberschrift;
BEGIN
  WRITELN;
  WRITELN('Loesungen der  quadratischen Gleichung:');
  WRITE('        X^2  +                  p        * x    +            q');
  WRITELN('              = 0');
  WRITELN('        x^2  +  ',p,'  * x    +  ',q,'  = 0');
  WRITELN;
  WRITELN;
END;

FUNCTION Sgn(An : double) : INTEGER;
BEGIN
  IF(An < -EPS) THEN Sgn := -1
  ELSE BEGIN
    IF (An > EPS) THEN Sgn := 1
    ELSE  Sgn := 0;
  END;
END;

PROCEDURE Haendisch;
VAR
Diskr : double;
BEGIN
  Diskr := -p/2.0 * (-p/2.0) - q;
  IF Sgn(Diskr) > 0 THEN BEGIN
     Hx1re := -p/2.0 + SQRT(Diskr); Hx1im := 0.0;
     Hx2re := -p/2.0 - SQRT(Diskr); Hx2im := 0.0;
     END ELSE IF Sgn(Diskr) = 0 THEN BEGIN
        Hx1re := -p/2.0; Hx1im := 0.0;
        Hx2re := Hx1re; Hx2im := 0.0;
     END ELSE BEGIN
       Hx1re := -p/2.0;
       Hx1im := SQRT(-Diskr);
       Hx2re := Hx1re;
       Hx2im := -SQRT(-Diskr);
     END;
  WRITELN('Mit der ueblichen Formel berechnet:');
  WRITELN('      double                            Imag');
  IF ABS(Hx1re) > ABS(Hx2re) THEN BEGIN
    WRITELN('x1: ',Hx1re,'      ',Hx1im);
    WRITELN('x2: ',Hx2re,'      ',Hx2im);
  END ELSE BEGIN
    WRITELN('x1: ',Hx2re,'      ',Hx2im);
    WRITELN('x2: ',Hx1re,'      ',Hx1im);
  END;
END;

PROCEDURE Maschine;
VAR
Diskr,Faktor : double;
BEGIN
  IF ABS(p) > 1.0 THEN BEGIN
    Faktor := ABS(p);
    Diskr := 1.0/4.0 - q/p/p;
  END ELSE BEGIN
    Faktor := 1.0;
    Diskr := p/2.0*p/2.0 - q;
    END;
  IF Diskr < 0.0 THEN BEGIN
    Mx1re := -p/2.0; Mx1im := Faktor * SQRT(-Diskr);
    Mx2re := Mx1re; Mx2im := -Mx1im;
  END ELSE BEGIN
    Mx1re := ABS(p/2.0) + Faktor * SQRT(Diskr);
    IF p > 0.0 THEN Mx1re := -Mx1re;
    IF Sgn(Mx1re) = 0 THEN Mx2re := 0.0 ELSE Mx2re := q/Mx1re;
  END;
  WRITELN;
  WRITELN;
  WRITELN('Mit der maschinengerechten Formel berechnet:');
  WRITELN('      double                            Imag');
  WRITELN('x1: ',Mx1re,'      ',Mx1im);
  WRITELN('x2: ',Mx2re,'      ',Mx2im);
END;

(* zur Rueckrechnung benoetigte Prozeduren *)
PROCEDURE Ca(VAR ZA : COMPLEX;ZB : COMPLEX);
  BEGIN
  ZA.re := ZA.re + ZB.re;
  ZA.im := ZA.im + ZB.im;
  END;

PROCEDURE Cm(VAR ZA : COMPLEX;ZB : COMPLEX);
  VAR
  H : COMPLEX;
  BEGIN
  H.re := ZA.re;
  H.im := ZA.im;
  ZA.re := (ZA.re*ZB.re)- (ZA.im*ZB.im);
  ZA.im := (H.re*ZB.im) + (H.im *ZB.re);
  END;

PROCEDURE Cneg(VAR ZA : COMPLEX);
  BEGIN
  ZA.re := -ZA.re;
  ZA.im := -ZA.im;
  END;

PROCEDURE RUeberschrift;
BEGIN
  WRITELN;
  WRITELN;
  WRITELN('Diese quadratische Gleichung wurde eingegeben:');
  WRITE('        X^2  +                  p        * x    +            q');
  WRITELN('              = 0');
  WRITELN('        x^2  +  ',p,'  * x    +  ',q,'  = 0');
  WRITELN;
  WRITELN;
  WRITELN;
  WRITELN;
  WRITELN('Jetzt werden die Koeffizienten p und q rueckgerechnet:');
END;

PROCEDURE RHaendisch;
  VAR
  H1,H2 : COMPLEX;
  BEGIN
    H1.re := Hx1re; H1.im := Hx1im;  H2.re := Hx2re; H2.im := Hx2im;
    Ca(H1,H2);
    Cneg(H1);
    Hrpre := H1.re; Hrpim := H1.im;
    H1.re := Hx1re; H1.im := Hx1im;
    Cm(H1,H2);
    Hrqre := H1.re; Hrqim := H1.im;
    WRITELN;
    WRITELN;
    WRITELN('uebliche Formel Ergebnisse zurueckgerechnet:');
    WRITELN('      double                            Imag');
    WRITELN('p: ',Hrpre,'      ',Hrpim);
    WRITELN('q: ',Hrqre,'      ',Hrqim);
  END;

PROCEDURE RMaschine;
  VAR
  H1,H2 : COMPLEX;
  BEGIN
    H1.re := Mx1re; H1.im := Mx1im;  H2.re := Mx2re; H2.im := Mx2im;
    Ca(H1,H2);
    Cneg(H1);
    Mrpre := H1.re; Mrpim := H1.im;
    H1.re := Mx1re; H1.im := Mx1im;
    Cm(H1,H2);
    Mrqre := H1.re; Mrqim := H1.im;
    WRITELN;
    WRITELN;
    WRITELN('Maschinengerechte Formel Ergebnisse zurueckgerechnet:');
    WRITELN('      double                            Imag');
    WRITELN('p: ',Mrpre,'      ',Mrpim);
    WRITELN('q: ',Mrqre,'      ',Mrqim);
  END;
{ ---------------------------- Hauptprogramm ------------------------------ }
BEGIN
  Eingabe;
  Ueberschrift;
  Haendisch;         { bei sehr grossem p mit Kommentarklammern ausklammern }
  Maschine;
  READLN;
  CLRSCR;
  RUeberschrift;
  RHaendisch;
  RMaschine;
  READLN;
END.
