							 //  11.Sept. 1998

#include <stdio.h>
#include <conio.h>
#include <math.h>

#define EPS 1.0e-12                                 /* fuer Nullvergleich */
#define reps 1.0e-6                                 // fuer Rueckrechnung

// --------------------- Variablen ----------------------------------------

long double an,bn,cn,dn,en;       /* Eingabekoeffizienten */
long double a,b,c,d;              /* Koeffizienen der normierten Gleichung */
				  /* Koeff von x^4 ist 1                   */
long double b1r,c1r,d1r;        /* Koeffizienten der reduzierten Gleichung */
				/* vierten Grades                          */

long double p1re,p1im,p2re,p2im,p3re,p3im;
long double x1re,x1im,x2re,x2im,x3re,x3im,x4re,x4im;
long double x1rered,x2rered,x3rered,x4rered;
long double x1imred,x2imred,x3imred,x4imred;
long double t1re,t1im,t2re,t2im,t3re,t3im;
int fallres;             // Fallunterscheidung bei der reduzierten kubischen
			 // Resolvente
int gl;

//  ------------------- fuer Rueckrechnung ----------------------------------
struct komplex                                // Record fr Komplexe Zahlen
 {
    long double re;
    long double im;
 }x1,x2,x3,x4,A,B,C,D,P,Q,H1,H2,H3,H4,H5,H6;      // x1,x2,x3,x4 Loesungen
					      // A,B,C,D Koeffizienten
					      // H1,H2,H3,H4 Hilfsvariablen
 long double ran,rbn,rcn,rdn,ren;           // rueckgerechnete Koeffizienten




/* --------------------- Prototypen der Unterprogramme ------------------ */
// Nur bei den Prototypen muss man void in der Parameterliste schreiben !!!
// Bei den eigentlichen Definitionen nur () !!!

int sgn(long double);
long double arccos(long double);
void standardform(void);
void reduktion(void);
void comsqrt2(long double,long double,long double *,long double *);
void resolvent(void);
void p6gleichung(void);
// void ausred(void);
void kombiminus(void);
void kombiplus(void);
void kombination(void);
void biquad(long double,long double );
void quartic(void);
void cubic(void);
void quadric(void);
void linear(void);
void noequ(void);
void allx(void);
void welchegleichung(int *);
void glei1bis4(long double,long double,long double,long double,long double,
	       long double *,long double *,long double *,long double *,
	       long double *,long double *,long double *,long double *,
	       int *);
void loesung(void);
void ausgabe(void);
void ausgangspolynom(void);

// ---------------------- fuer Rueckrechnung -------------------------------
void rueckeingabe(void);
struct komplex kadd(struct komplex,struct komplex);
struct komplex kmult(struct komplex,struct komplex);
struct komplex kneg(struct komplex);
void rueck4(void);
void rueck3(void);
void rueck2(void);
void ruecklin(void);
void rallx(void);
void rnoequ(void);
void rueckrechnung(void);
void rueckausgabe(void);

/* ------------------------ Unterprogramme ------------------------------ */
int sgn(long double x) {
  int vz;
  if(x < -EPS) vz = -1;
  else {
    if (x > EPS) vz = 1;
      else vz = 0;
  }
  return(vz);
}

long double  arccos(long double x) {
  long double u;
  if (sgn(x) == 0)  return(M_PI/2.0);
  else u = atan(sqrtl(1-x*x)/x) + (1.0 - sgn(x))*(M_PI/2.0);
  return(u);
}

void standardform() {
  if (sgn(an) != 0) {
    a = bn/an;
    b = cn/an;
    c = dn/an;
    d = en/an;
  }
}

void reduktion() {
  if (sgn(a) == 0) {
    b1r = b;
    c1r = c;
    d1r = d;
  }
  else
  b1r = b - (3.0*a*a)/8.0;
  c1r = c - (a*b)/2.0 + (a*a*a)/8.0;
  d1r = d - (a*c)/4.0 + (a*a*b)/16.0 - (3.0*a*a*a*a)/256.0;
/*
  printf("Reduzierte Gleichung  ");
  printf("b1r =  %10.5Lf   c1r = %10.5Lf d1r =  %10.5Lf\n",b1r,c1r,d1r);
  getch();
*/
}

void resolvent() {
			// p^6 + a2*p^4 + b2*p^2 + c2 = 0
			// t^3 + a2*t^2 + b2*T + c2 = 0
			// z = Loesung der reduzierten kubischen  Resolvente
			// z^3 + pk*z + qk = 0
			// Loesung der kubischen Resolvente  t = z - a2/3

 int usign,vsign;
 long double  a2,b2,c2,pk,qk,disk,u,v,uh,vh,phi,z1re,z1im,z2re,z2im,z3re,z3im;

  a2 = 2.0*b1r;
  b2 = b1r*b1r - 4*d1r;
  c2 = -c1r*c1r;
/*
  printf("Resolvente  ");
  printf("a2 = %10.5Lf",a2); printf(" b2 = %10.5Lf",b2);
  printf("  c2 =%10.5Lf \n",c2);
  getch();
*/
		       /* Loesung der kubischen Resolvente  t = z - a2/3  */

  pk = -(a2*a2)/3.0 + b2;
						   /* Z^3 + pk*Z + qk = 0 */
  qk = 2.0*(a2*a2*a2)/27.0 - a2*b2/3.0 + c2;
  disk = qk*qk/4.0 + (pk*pk*pk)/27.0;
  fallres= sgn(disk);

  switch(fallres)
     {
				// Fall1= 1 reelle,2 konj.komplexe Loesungen
     case 1:
	uh =   -qk/2.0 + sqrtl(disk);  usign = sgn(uh);
	vh =   -qk/2.0 - sqrtl(disk);  vsign = sgn(vh);
	if (sgn(uh) == 0)
	   u = 0.0;
	else u = expl((1.0/3.0)*logl(fabsl(uh))) * usign;
	if (sgn(vh) == 0)
	   v = 0.0;
	else v = expl((1.0/3.0)*logl(fabsl(vh))) * vsign;
	z1re = u + v; z1im = 0.0;
	z2re = -(u + v)/2.0; z2im = (u - v)/2.0 * sqrtl(3.0);
	z3re = z2re; z3im = -z2im;
	break;

     case 0:                         /* 1 reelle, 1 reelle Doppelloesung */
	uh = -qk/2.0; usign = sgn(uh);
	vh = -qk/2.0; vsign = sgn(vh);
	if (sgn(uh) == 0)
	   u = 0.0;
	else u = expl((1.0/3.0)*logl(fabsl(uh))) * usign;
	if (sgn(vh) == 0)
	  v = 0.0;
	else v = expl((1.0/3.0)*logl(fabsl(vh))) * vsign;
	z1re = 2*u; z1im = 0.0;
	z2re = -u; z2im = 0.0;
	z3re = z2re; z3im = z2im;
	break;

    case -1:                                /* Fall3= casus irreducibilis */
	uh = -(pk*pk*pk)/27.0;              // 3 reelle Loesungen
	// printf("Resolvente Casus irreducibilis uh =  ");
	// printf("%10.5Lf\n ",uh);
	// getch();
	phi = arccos((-qk/2.0)/sqrtl(uh));
	z1re =  2.0*sqrtl(-pk/3.0) * cos(phi/3.0);
	z2re =  2.0*sqrtl(-pk/3.0) * cos(phi/3.0 + (2.0*M_PI/3.0));
	z3re =  2.0*sqrtl(-pk/3.0) * cos(phi/3.0 - (2.0*M_PI/3.0));
	z1im = 0.0; z2im = 0.0; z3im = 0.0;
	break;
  }
  t1re = z1re - a2/3.0; t1im = z1im;
  t2re = z2re - a2/3.0; t2im = z2im;
  t3re = z3re - a2/3.0; t3im = z3im;
/*
  printf("pk = %10.5Lf   qk  = %10.5Lf",pk,qk);
  printf("  fallres = %4d \n",fallres);
  printf("z1re = %10.5Lf  z1im = %10.5Lf\n",z1re,z1im);
  printf("z2re = %10.5Lf  z2im = %10.5Lf\n",z2re,z2im);
  printf("z3re = %10.5Lf  z3im = %10.5Lf\n",z3re,z3im);

  printf("t1re =  %10.5Lf  t1im =  %10.5Lf\n",t1re,t1im);
  printf("t2re =  %10.5Lf  t2im =  %10.5Lf\n",t2re,t2im);
  printf("t3re =  %10.5Lf  t3im =  %10.5Lf\n",t3re,t3im);
  getch();
*/
}

void p6gleichung() {
  comsqrt2(t1re,t1im,&p1re,&p1im);
  comsqrt2(t2re,t2im,&p2re,&p2im);
  comsqrt2(t3re,t3im,&p3re,&p3im);
/*
  printf("p1re  = %10.5Lf   p1im = %10.5Lf\n",p1re,p1im);
  printf("p2re  = %10.5Lf   p2im = %10.5Lf\n",p2re,p2im);
  printf("p3re  = %10.5Lf   p3im = %10.5Lf\n",p3re,p3im);
  printf("Das Vorzeichen von c1r =  %4d\n",sgn(c1r));
*/
}

void kombiplus()
{
    x1re = 0.5 * (p1re + p2re + p3re) - a/4.0;
    x2re = 0.5 * (p1re - p2re - p3re) - a/4.0;
    x3re = 0.5 * (-p1re - p2re + p3re) - a/4.0;
    x4re = 0.5 * (-p1re + p2re - p3re) - a/4.0;

    x1im = 0.5 * (p1im + p2im + p3im);
    x2im = 0.5 * (p1im - p2im - p3im);
    x3im = 0.5 * (-p1im - p2im + p3im);
    x4im = 0.5 * (-p1im + p2im - p3im);
    // printf("Es wurde kombiplus ausgefuehrt\n");
}

void kombiminus()
{
    x1re = 0.5 * (-p1re - p2re - p3re) - a/4.0;
    x2re = 0.5 * (-p1re + p2re + p3re) - a/4.0;
    x3re = 0.5 * (p1re + p2re - p3re) - a/4.0;
    x4re = 0.5 * (p1re - p2re + p3re) - a/4.0;

    x1im = 0.5 * (-p1im - p2im - p3im);
    x2im = 0.5 * (-p1im + p2im + p3im);
    x3im = 0.5 * (p1im + p2im - p3im);
    x4im = 0.5 * (p1im - p2im + p3im);
    // printf("Es wurde kombiminus ausgefuehrt\n");
}

void kombination() {
  int fall;
  int vzt;
 vzt = sgn(t1re) + sgn(t2re) + sgn(t3re);
  if ((fallres == -1) || (fallres == 0)) {
    fall = vzt + sgn(c1r);
    switch(fall) {
      case  4: kombiminus();
	       break;
      case  2: kombiplus();
	       break;
      case  0: kombiplus();
	       break;
      case -2: kombiminus();
    }
  }

  if (fallres == 1) {                             // c1r kann nicht null sein
    if (sgn(c1r) == 1) kombiplus();                // c1r = 0 ist biquad2 fall
    else kombiminus();
  }
}

/*
void ausred() {
//  printf("Loesungen der reduzierten Gleichung  \n");
    x1rered = x1re + a/4.0; x1imred = x1im ;
    x2rered = x2re + a/4.0; x2imred = x2im ;
    x3rered = x3re + a/4.0; x3imred = x3im ;
    x4rered = x4re + a/4.0; x4imred = x4im ;

    printf("x1rered   = %10.5Lf   x1imred = %10.5Lf\n",x1rered,x1imred);
    printf("x2rered   = %10.5Lf   x2imred = %10.5Lf\n",x2rered,x2imred);
    printf("x3rered   = %10.5Lf   x3imred = %10.5Lf\n",x3rered,x3imred);
    printf("x4rered   = %10.5Lf   x4imred = %10.5Lf\n",x4rered,x4imred);

}
*/

void comsqrt2(  long double a,  long double b,  long double *pu,  long double *pv) {
    long double vz;                             // Vorzeichenkorrekturfaktor
  vz =  1.0 + sgn(b) - sgn(b)*sgn(b);
  *pu = vz*sqrtl(0.5*(a + sqrtl(a*a + b*b)));
  *pv = sqrtl(0.5*(-a + sqrtl(a*a + b*b)));
}

void biquad(long double l, long double m) {
  int ent;
   long double disk,s,s1,s2,sre,sim,s1re,s1im,s2re,s2im;

  disk = l*l - 4.0*m;
  ent = sgn(disk);
  switch(ent)
     {
	case  1 :
	   s1 = (-l + sqrtl(disk)) / 2.0;
	   s2 = (-l - sqrtl(disk)) / 2.0;
	   s = s1;
	   x1re = 0.5*sqrtl(s*sgn(s)) * (1.0 + sgn(s));
	   x1im = 0.5*sqrtl(s*sgn(s)) * (1.0 - sgn(s));
	   x2re = -x1re;
	   x2im = -x1im;
	   s = s2;
	   x3re = 0.5*sqrtl(s*sgn(s)) * (1.0 + sgn(s));
	   x3im = 0.5*sqrtl(s*sgn(s)) * (1.0 - sgn(s));
	   x4re = -x3re;
	   x4im = -x3im;
	   break;
	case 0 :
	   s1 = -l / 2.0;
	   s2 = s1;
	   s = s1;
	   x1re = 0.5*sqrtl(s*sgn(s)) * (1.0 + sgn(s));
	   x1im = 0.5*sqrtl(s*sgn(s)) * (1.0 - sgn(s));
	   x2re = -x1re;
	   x2im = -x1im;
	   x3re = x1re;
	   x3im = x1im;
	   x4re = x2re;
	   x4im = x2im;
	   break;
	case -1 :
	   s1re = -l / 2.0;
	   s1im = sqrtl(-disk) / 2.0;
	   s2re = -l / 2.0;
	   s2im = -sqrtl(-disk) / 2.0;
	   sre = s1re;
	   sim = s1im;
	   // printf("s1re = %10.5Lf",s1re); printf("   s1im = %10.5Lf\n",s1im);
	   x1re = sqrtl(0.5*(sre + sqrtl(sre*sre + sim*sim)));
	   x1im = sgn(sim)*sqrtl(0.5*(-sre + sqrtl(sre*sre + sim*sim)));
	   x2re = -x1re;
	   x2im = -x1im;
	   sre = s2re;
	   sim = s2im;
	   // printf("s2re = %10.5Lg",s2re); printf("   s2im = %Lg.5",s2im);
	   x3re = -sqrtl(0.5*(sre + sqrtl(sre*sre + sim*sim)));
	   x3im = -sgn(sim)*sqrtl(0.5*(-sre + sqrtl(sre*sre + sim*sim)));
	   x4re = -x3re;
	   x4im = -x3im;
	   break;
  }
  if (sgn(c1r) == 0) {
    x1re = x1re - a/4.0;
    x2re = x2re - a/4.0;
    x3re = x3re - a/4.0;
    x4re = x4re - a/4.0;
    // printf("\nreduzierte Gleichung ist biquadratisch\n    ");
  }
// printf("ent  = %4d\n",ent);
}

void quartic()
{
standardform();
  if ((sgn(a) == 0) && (sgn(c) == 0)) {
     // printf("biquad schon bei der Eingabe\n");
     // getch();
     biquad(b,d);
  }
  else {
    reduktion();
    if (sgn(c1r) == 0) {
      biquad(b1r,d1r);
    }
    else {
      resolvent();
      p6gleichung();
      kombination();
    }
  }
}

void cubic() {                            // X^3 + A2*X^2 + B2*X +   C2 = 0
			// Z = Loesung der reduzierten kubischen  Gleichung
			//   Z^3 + Pk*Z + Qk = 0
			//  Loesung der kubischen Gleichung   X = Z - A2/3
long double a2,b2,c2,pk,qk,disk,u,v,uh,vh,phi,z1re,z1im,z2re,z2im,z3re,z3im;
int fallkub,usign,vsign;

  a2 = cn/bn;
  b2 = dn/bn;
  c2 = en/bn;

  pk = -(a2*a2)/3.0 + b2;
						      // Z^3 + pk*Z + qk = 0
  qk = 2.0*(a2*a2*a2)/27.0 - a2*b2/3.0 + c2;
						     //  pk = -2.0; qk = 1.0;
  disk = qk*qk/4.0 + (pk*pk*pk)/27.0;
  fallkub = sgn(disk);
  switch(fallkub) {

				// Fall1: 1 reelle,2 konj.komplexe Loesungen
     case 1:
	uh =   -qk/2.0 + sqrtl(disk);  usign = sgn(uh);
	vh =   -qk/2.0 - sqrtl(disk);  vsign = sgn(vh);
	if (sgn(uh) == 0)
	  u = 0.0;
	else u = expl((1.0/3.0)*logl(fabsl(uh))) * usign;
	if (sgn(vh) == 0)
	   v = 0.0;
	else v = expl((1.0/3.0)*logl(fabsl(vh))) * vsign;
	z1re = u + v; z1im = 0.0;
	z2re = -(u + v)/2.0; z2im = (u - v)/2.0 * sqrtl(3.0);
	z3re = z2re; z3im = -z2im;
	break;

    case 0:                           // 1 reelle, 1 reelle Doppelloesung
	uh = -qk/2.0; usign = sgn(uh);
	vh = -qk/2.0; vsign = sgn(vh);
	if (sgn(uh) == 0)
	  u = 0.0;
	else u = expl((1.0/3.0)*logl(fabsl(uh))) * usign;
	if (sgn(vh) == 0)
	  v = 0.0;
	else v = expl((1.0/3.0)*logl(fabsl(vh))) * vsign;
	z1re = 2*u; z1im = 0.0;
	z2re = -u; z2im = 0.0;
	z3re = z2re; z3im = z2im;
	break;

    case -1:                                  // Fall3: casus irreducibilis
	uh = -(pk*pk*pk)/27.0;
	phi = arccos((-qk/2.0)/sqrtl(uh));
	z1re =  2.0*sqrtl(-pk/3.0) * cos(phi/3.0);
	z2re =  2.0*sqrtl(-pk/3.0) * cos(phi/3.0 + (2.0*M_PI/3.0));
	z3re =  2.0*sqrtl(-pk/3.0) * cos(phi/3.0 - (2.0*M_PI/3.0));
	z1im = 0.0; z2im = 0.0; z3im = 0.0;
       break;
  }
  x1re = z1re - a2/3.0; x1im = z1im;
  x2re = z2re - a2/3.0; x2im = z2im;
  x3re = z3re - a2/3.0; x3im = z3im;

/*
  printf("\n");
  printf("Koeffizienten der reduzierten Gleichung:\n");
  printf("z^3     +        pk *Z           +        qk       =  0\n");
  printf("                %10.5Lf                %10.5Lf\n",pk,qk);
  printf("\n");
  printf("Fallunterscheidung kubische Gleichung : %5d\n",fallkub);
  printf("\n");
  printf("Loesungen der reduzierten kubischen Gleichung:\n");
  printf("z1re =  %8.4Lf  z1im =  %8.4Lf\n",z1re,z1im);
  printf("z2re =  %8.4Lf  z2im =  %8.4Lf\n",z2re,z2im);
  printf("z3re =  %8.4Lf  z3im =  %8.4Lf\n",z3re,z3im);
  getch();
*/
}

void quadric() {
  long double p,q,diskr;
  p = dn/cn; q = en/cn;
  diskr = -p/2.0 * (-p/2.0) - q;
  if (sgn(diskr) > 0.0) {
     x1re = -p/2.0 + sqrtl(diskr); x1im = 0.0;
     x2re = -p/2.0 - sqrtl(diskr); x2im = 0.0;
  } else if (sgn(diskr) == 0.0) {
	x1re = -p/2.0; x1im = 0.0;
	x2re = x1re; x2im = 0.0;
    } else {
       x1re = -p/2.0;
       x1im = sqrtl(-diskr);
       x2re = x1re;
       x2im = -sqrtl(-diskr);
      }
}

void linear() {
  long double a,b;
  a = dn;
  b = en;
  x1re = -b/a;
}

void noequ() {
  // printf("keine Gleichung\n");
}

void allx() {
  // printf("Gleichung fuer alle x erfuellt\n");
}


void glei1bis4(long double anh,long double bnh,long double cnh,long double dnh,
	       long double enh,long double *hx1re,long double *hx1im,
	       long double *hx2re,long double *hx2im,long double *hx3re,
	       long double *hx3im,long double *hx4re,long double *hx4im,
	       int * gx)
{
 an = anh;
 bn = bnh;
 cn = cnh;
 dn = dnh;
 en = enh;
 welchegleichung(&gl);
 loesung();

 *hx1re = x1re;  *hx2re = x2re; *hx3re = x3re; *hx4re = x4re;
 *hx1im = x1im;  *hx2im = x2im; *hx3im = x3im; *hx4im = x4im;
 *gx = gl;
}

void loesung() {
  switch(gl) {
    case   4: quartic();
	    break;
    case   3: cubic();
	    break;
    case   2: quadric();
	    break;
    case   1: linear();
	    break;
    case   0: noequ();
	    break;
    case 999: allx();
  }
}

void welchegleichung(int *gl) {
  if (sgn(an) != 0) *gl = 4;
  else if (sgn(bn) != 0) *gl =3;
    else if (sgn(cn) != 0) *gl = 2;
      else if (sgn(dn) != 0) *gl = 1;
	else if (sgn(en) != 0) *gl = 0;
	else *gl = 999;
}

void ausgabe() {
  switch(gl) {
     case 4:
       printf("\n"); printf("\n");
       printf("Loesungen der Gleichung vierten Grades:\n");
       printf("    A * X^4   +    B * X^3    +   C * X^2    +   D * X  +  ");
       printf("  E       =       0 \n");
       printf("\n");
       printf("%10.5Lf   %10.5Lf     %10.5Lf    %10.5Lf   %10.5Lf\n",an,bn,cn,dn,en);
       printf("\n");
       printf("       Real          Imag\n");
       printf("X1: %10.5Lf    %10.5Lf\n",x1re,x1im);
       printf("X2: %10.5Lf    %10.5Lf\n",x2re,x2im);
       printf("X3: %10.5Lf    %10.5Lf\n",x3re,x3im);
       printf("X4: %10.5Lf    %10.5Lf\n",x4re,x4im);
       break;
     case 3:
       printf("\n"); printf("\n");
       printf("Loesungen der Gleichung dritten Grades:\n");
       printf("    A * X^3   +   B * X^2    +    C * X     +    D");
       printf("        =     0\n");
       printf("\n");
       printf("%10.5Lf   %10.5Lf     %10.5Lf    %10.5Lf\n",bn,cn,dn,en);
       printf("\n");
       printf("       Real          Imag\n");
       printf("X1: %10.5Lf    %10.5Lf\n",x1re,x1im);
       printf("X2: %10.5Lf    %10.5Lf\n",x2re,x2im);
       printf("X3: %10.5Lf    %10.5Lf\n",x3re,x3im);
       break;
     case 2:
       printf("\n"); printf("\n");
       printf("Loesungen der quadratischen Gleichung:\n");
       printf("     A * X^2    +    B * X    +    C          =       0\n");
       printf("\n");
       printf("%10.5Lf     %10.5Lf     %10.5Lf\n",cn,dn,en);
       printf("\n");
       printf("       Real          Imag\n");
       printf("X1: %10.5Lf    %10.5Lf\n",x1re,x1im);
       printf("X2: %10.5Lf    %10.5Lf\n",x2re,x2im);
       break;
     case 1:
       printf("\n"); printf("\n");
       printf("Loesung der linearen  Gleichung:\n");
       printf("     A * X     +     B         =         0\n");
       printf("\n");
       printf(" %10.5Lf    %10.5Lf\n",dn,en);
       printf("\n");
       printf("X1: %10.5Lf\n",x1re);
       break;
     case 999:
       printf("\n"); printf("\n");
       printf("eingegebene Gleichung:\n");
       printf("     A * X     +      B          =        0");
       printf("\n");
       printf(" %10.5Lf      %10.5Lf\n",dn,en);
       printf("\n");
       printf("Die Gleichung ist fuer jedes reelle X erfuellt.\n");
       break;
     case 0:
       printf("\n"); printf("\n");
       printf("eingegebene Gleichung:\n");
       printf("     A * X     +      B          =        0");
       printf("\n");
       printf(" %10.5Lf      %10.5Lf\n",dn,en);
       printf("\n");
       printf("Es existiert keine Loesung.\n");
       break;
  }
}

void  ausgangspolynom()
{
  printf("\n");
  printf("Das urspruenglich eingegebene Polynom vierten Grades:\n");
  printf("    A * X^4   +    B * X^3    +   C * X^2    +   D * X  +  ");
  printf("  E       =       0 \n");
  printf("\n");
  printf("%10.5Lf   %10.5Lf     %10.5Lf    %10.5Lf   %10.5Lf\n",an,bn,cn,dn,en);
}


// ----------------------- fuer Rueckrechnung ------------------------------

void rueckeingabe(void)
{
  x1.re = x1re;
  x1.im = x1im;
  x2.re = x2re;
  x2.im = x2im;
  x3.re = x3re;
  x3.im = x3im;
  x4.re = x4re;
  x4.im = x4im;
/*
  printf("\n");
  printf("\n");
  printf("\n");
  printf("Folgende Loesungen werden fuer die Rueckrechnung verwendet:");
  printf("\n");
  printf("Loesung x1:   %+Lg  %+Lg*i\n",x1.re,x1.im);
  printf("Loesung x2:   %+Lg  %+Lg*i\n",x2.re,x2.im);
  printf("Loesung x3:   %+Lg  %+Lg*i\n",x3.re,x3.im);
  printf("Loesung x4:   %+Lg  %+Lg*i\n",x4.re,x4.im);
  printf("\n");
*/
}


struct komplex kadd(struct komplex z1, struct komplex z2)
{
  struct komplex z3;
  z3.re = z1.re + z2.re;
  z3.im = z1.im + z2.im;
  return z3;
}


struct komplex kmult(struct komplex z1, struct komplex z2)
{
  struct komplex z3;
  z3.re = (z1.re*z2.re) - (z1.im*z2.im);
  z3.im = (z1.re*z2.im) + (z1.im*z2.re);
  return z3;
}


struct komplex kneg(struct komplex z)
{
  struct komplex z3;
  z3.re = -z.re;
  z3.im = -z.im;
  return z3;
}

void rueck4()
{
  H1 = kadd(x1,x2);                             // Summe von x1 und x2
  H2 = kadd(x3,x4);
  H3 = kadd(H1,H2);
  A = kneg(H3);                                 // negative Summe

  H1 = kmult(x1,x2);
  H2 = kmult(x1,x3);
  H3 = kadd(H1,H2);
  H1 = kmult(x1,x4);
  H2 = kmult(x2,x3);
  H4 = kadd(H1,H2);
  H5 = kadd(H3,H4);
  H1 = kmult(x2,x4);
  H2 = kmult(x3,x4);
  H6 = kadd(H1,H2);
  B = kadd(H5,H6);

  H1 = kmult(x1,x2);
  H2 = kmult(H1,x3);
  H3 = kmult(H1,x4);
  H4 = kadd(H2,H3);
  H1 = kmult(x1,x3);
  H2 = kmult(H1,x4);
  H3 = kmult(x2,x3);
  H5 = kmult(H3,x4);
  H6 = kadd(H2,H5);
  H1 = kadd(H4,H6);
  C = kneg(H1);

  H1 = kmult(x1,x2);
  H2 = kmult(x3,x4);
  D = kmult(H1,H2);

  ran = an;
  rbn = A.re * an;
  rcn = B.re * an;
  rdn = C.re * an;
  ren = D.re * an;
}

void rueck3() {
  H1 = kadd(x1,x2);                             // Summe von x1 und x2
  H2 = kadd(H1,x3);
  A = kneg(H2);                                 // negative Summe

  H1 = kmult(x1,x2);
  H2 = kmult(x1,x3);
  H3 = kmult(x2,x3);
  H4 = kadd(H1,H2);
  B = kadd(H4,H3);

  H1 = kmult(x1,x2);
  H2 = kmult(H1,x3);
  C = kneg(H2);

  rbn = bn;
  rcn = A.re * bn;
  rdn = B.re * bn;
  ren = C.re * bn;
}

void rueck2() {
  x1.re = x1re; x1.im = x1im;
  x2.re = x2re; x2.im = x2im;
  P = kadd(x1,x2);                             // Summe
  P = kneg(P);                                 // negative Summe
  Q = kmult(x1, x2);

  rcn = cn;
  rdn = P.re * cn;
  ren = Q.re * cn;
}

void ruecklin() {
  rdn = dn;
  ren = -x1re*dn;
}

void rallx() {
  // printf(" Keine Rueckrechnung zielfuehrend\n");
}

void rnoequ() {
  // printf(" Keine Rueckrechnung zielfuehrend\n");
}

void rueckrechnung() {
  switch(gl) {
    case   4: rueck4();
	    break;
    case   3: rueck3();
	    break;
    case   2: rueck2();
	    break;
    case   1: ruecklin();
	    break;
    case   0: rnoequ();
	    break;
    case 999: rallx();
  }
}

void rueckausgabe() {
  switch(gl) {
     case 4:
       printf("\n"); printf("\n");
       printf(" Rueckrechnung der Gleichung vierten Grades:\n");
       printf("    A * X^4   +    B * X^3    +   C * X^2    +   D * X  +  ");
       printf("  E       =       0 \n");
       printf("\n");
       printf("%10.5Lf   %10.5Lf     %10.5Lf    %10.5Lf   %10.5Lf\n",
	      ran,rbn,rcn,rdn,ren);
       break;
     case 3:
       printf("\n"); printf("\n");
       printf(" Rueckrechnung der Gleichung dritten Grades:\n");
       printf("    A * X^3   +   B * X^2    +    C * X     +    D");
       printf("        =     0\n");
       printf("\n");
       printf("%10.5Lf   %10.5Lf     %10.5Lf    %10.5Lf\n",rbn,rcn,rdn,ren);
       break;
     case 2:
       printf("\n"); printf("\n");
       printf(" Rueckrechnung der quadratischen Gleichung:\n");
       printf("     A * X^2    +    B * X    +    C          =       0\n");
       printf("\n");
       printf("%10.5Lf     %10.5Lf     %10.5Lf\n",rcn,rdn,ren);
       break;
     case 1:
       printf("\n"); printf("\n");
       printf(" Rueckrechnung der linearen  Gleichung:\n");
       printf("     A * X     +     B         =         0\n");
       printf("\n");
       printf(" %10.5Lf    %10.5Lf\n",rdn,ren);
       break;
     case 999:
       printf("\n"); printf("\n");
       printf("eingegebene Gleichung:\n");
       printf("     A * X     +      B          =        0");
       printf("\n");
       printf(" %10.5Lf      %10.5Lf\n",dn,en);
       printf("\n");
       printf("Rueckrechnung nicht zielfuehrend:\n");
       printf("da die Gleichung fuer jedes X erfuellt ist.\n");
       break;
     case 0:
       printf("\n"); printf("\n");
       printf("eingegebene Gleichung:\n");
       printf("     A * X     +      B          =        0");
       printf("\n");
       printf(" %10.5Lf      %10.5Lf\n",dn,en);
       printf("\n");
       printf("Rueckrechnung nicht zielfuehrend:\n");
       printf("da keine Loesung existiert.\n");
       break;
  }
}

